%{?scl:%scl_package %{_name}}
%{!?scl:%global pkg_name %{name}}

%global _version    1.0.0
%global real_name   deep_merge
%global gem_name    deep-merge
%global _name       rubygem-%{gem_name}

%if 0%{?fedora} >= 17
%global gemdir     /usr/share/gems
%else
%global gemdir     /usr/lib/ruby/gems/1.8
%endif

%define gem         %{_bindir}/gem
%define geminstdir  %{gemdir}/gems/%{real_name}-%{_version}

Name:               %{?scl_prefix}%{_name}
Version:            %{_version}
Release:            1%{?dist}
Vendor:             %{?_host_vendor}
Summary:            Recursively merge hashes

Group:              Development/Languages
License:            MIT
URL:                http://rubygems.org/gems/%{real_name}/versions/%{_version}
Source0:            %{real_name}-%{version}.gem

BuildRoot:          %{_tmppath}/%{pkg_name}-%{version}-%{release}-%(id -un)
BuildArch:          noarch

%{?scl:Requires: %{scl}-runtime}
BuildRequires:      %{?scl_prefix}ruby
BuildRequires:      %{?scl_prefix}rubygems

Requires:           %{?scl_prefix}ruby
Requires:           %{?scl_prefix}rubygems

Provides:           %{?scl_prefix}rubygems(%{gem_name}) = %{_version}

%description
Deep Merge is a simple set of utility function for Hash. It permits
you to merge elements inside a hash together recursively. The manner
by which it does this is somewhat arbitrary {since there is no defining
standard for thi) but it should end up being pretty intuitive and do what
you expect.

%prep

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{gemdir}
%{gem} install --local --install-dir $RPM_BUILD_ROOT%{gemdir} \
        --force --rdoc %{SOURCE0}

# Remove backup files
find $RPM_BUILD_ROOT%{geminstdir} -type f -name '*~' -delete

# Delete zero-length files
find $RPM_BUILD_ROOT%{geminstdir} -type f -size 0c -exec rm -rvf {} \;

# Fix anything executable that does not have a shebang
for file in `find $RPM_BUILD_ROOT%{geminstdir} -type f -perm /a+x`; do
  [ -z "`head -n 1 $file | grep \"^#!/\"`" ] && chmod -v 644 $file
done

# Find files with a shebang that do not have executable permissions
for file in `find $RPM_BUILD_ROOT%{geminstdir} -type f ! -perm /a+x -name "*.rb"`; do
  [ ! -z "`head -n 1 $file | grep \"^#!/\"`" ] && chmod -v 755 $file
done

# Find files that have non-standard-executable-perm
find $RPM_BUILD_ROOT%{geminstdir} -type f -perm /g+wx -exec chmod -v g-w {} \;

# Find files that are not readable
find $RPM_BUILD_ROOT%{geminstdir} -type f ! -perm /go+r -exec chmod -v go+r {} \;

# Fix shebang ling of scripts
for file in `find $RPM_BUILD_ROOT%{_prefix} -type f`; do
  sed -i -e '1s,^#!.*ruby$,#!%{_bindir}/ruby,' $file
done

# Remove docs
rm -rf $RPM_BUILD_ROOT/%{gemdir}/doc/%{gem_name}-%{version}
rm -rf $RPM_BUILD_ROOT/%{geminstdir}/test
rm -rf $RPM_BUILD_ROOT/%{geminstdir}/Rakefile

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{geminstdir}/lib
%doc %{geminstdir}/README
%doc %{geminstdir}/CHANGELOG
%doc %{geminstdir}/VERSION
%doc %{gemdir}/doc
%{gemdir}/cache/%{real_name}-%{version}.gem
%{gemdir}/specifications/%{real_name}-%{version}.gemspec

%changelog
* Thu Jul 25 2013 Melissa Stone <melissa@puppetlabs.com> - 1.0.0-1
- Initial packaging for FOSS
